#include "..\TA_Firmware\TAF_00D.h"
#include "..\TA_Firmware\TAF_00P.h"
#include "..\MyLib\in_out.h"

void motor (UCHAR ucNummer,signed char cSpeed)
{
	UCHAR ucBitmask, ucLmask, ucBit;

	ucNummer --;							// Wertebereich von ucNummer auf 1-16 umwandeln

	if (cSpeed < -8)						// Falls cSpeed auerhalb des Wertebereichs sein sollte, wird das hier korrigiert
		cSpeed = -8;
	if (cSpeed > 8)
		cSpeed = 8;

	sTrans.ucDbg1F0 = cSpeed;

	ucBit = (ucNummer & 0x03) * 2;			// Jeder Motor braucht 2 ucBits, deshalb nur 4 Motoren pro Modul

	ucBitmask = 0;							// Bitmaske fr den Motor-Stop-Fall vordefinieren

	if (cSpeed > 0)							// Motor rechts herum
		ucBitmask = (2 << (ucBit));			// 2 = Binr 10
	if (cSpeed < 0)							// Motor links herum
		ucBitmask = (1 << (ucBit));			// 1 = Binr 01

	if (cSpeed < 0)
		cSpeed = -cSpeed;					// Absolut-Funktion fr ein Byte. ABS() arbeitet mit Integer...

	
	ucLmask = ~(3 << ucBit);				// Lschmaske (die ucBits mssen vorher gelscht werden)

/*	Wurde zum Debuggen benutzt
	sTrans.ucDbg1F1 = cSpeed;
	sTrans.ucDbg1F2 = ucNummer >> 2;
	sTrans.ucDbg1F3 = ucLmask;
	sTrans.ucDbg1F4 = ucBitmask;
	sTrans.ucDbg1F5 = ucBit;	
*/
	if (ucNummer < 16)
	{
		switch (ucNummer >> 2)				// ucNummer Modulo 4
		{
			case 0:
				sTrans.MPWM_Main[ucBit] = cSpeed - 1;
				sTrans.MPWM_Main[ucBit + 1] = cSpeed -1;
				sTrans.M_Main = (sTrans.M_Main & ucLmask) | ucBitmask;
				break;
			case 1:
				sTrans.MPWM_Sub1[ucBit] = cSpeed - 1;
				sTrans.MPWM_Sub1[ucBit + 1] = cSpeed -1;
				sTrans.M_Sub1 = (sTrans.M_Sub1 & ucLmask) | ucBitmask;
				break;
			case 2:
				sTrans.MPWM_Sub2[ucBit] = cSpeed - 1;
				sTrans.MPWM_Sub2[ucBit + 1] = cSpeed -1;
				sTrans.M_Sub2 = (sTrans.M_Sub2 & ucLmask) | ucBitmask;
				break;
			case 3:
				sTrans.MPWM_Sub3[ucBit] = cSpeed - 1;
				sTrans.MPWM_Sub3[ucBit + 1] = cSpeed -1;
				sTrans.M_Sub3 = (sTrans.M_Sub3 & ucLmask) | ucBitmask;
				break;						// nicht notwendig - hilft aber, Fehler zu vermeiden...
		}
		sTrans.MPWM_Update = 0x02;  		// Update PWM values one time
	}
}

void output (UCHAR ucNummer, UCHAR cSpeed)
{
	UCHAR ucBitmask, ucBit;

	ucNummer --;							// Wertebereich von ucNummer auf 1-32 umwandeln

	if (cSpeed > 8)
		cSpeed = 8;

	ucBit = ucNummer & 0x07;
	ucBitmask = (1<<ucBit);					// Eine ucucBitmaske berechnen

	if (ucNummer < 32)						// Sicherheitsabfrage. Falls die ucNummer zu gro ist, passiert nichts.
	{
		switch (ucNummer >> 3)				// ucNummer Modulo 8
		{
			case 0:
				sTrans.MPWM_Main[ucBit] = cSpeed - 1;
				if (cSpeed == 0)
					sTrans.M_Main &= ~ucBitmask;
				else
					sTrans.M_Main |= ucBitmask;
				break;
			case 1:
				sTrans.MPWM_Sub1[ucBit] = cSpeed - 1;
				if (cSpeed == 0)
					sTrans.M_Sub1 &= ~ucBitmask;
				else
					sTrans.M_Sub1 |= ucBitmask;
				break;
			case 2:
				sTrans.MPWM_Sub2[ucBit] = cSpeed - 1;
				if (cSpeed == 0)
					sTrans.M_Sub2 &= ~ucBitmask;
				else
					sTrans.M_Sub2 |= ucBitmask;
				break;
			case 3:
				sTrans.MPWM_Sub3[ucBit] = cSpeed - 1;
				if (cSpeed == 0)
					sTrans.M_Sub3 &= ~ucBitmask;
				else
					sTrans.M_Sub3 |= ucBitmask;
				break;
		}
		sTrans.MPWM_Update = 0x02;  		// Update PWM values one time
	}
}

UINT input (UCHAR ucNummer)
{
	UCHAR ucBit;

	ucNummer --;

	ucBit = ucNummer & 0x07;

	if (ucNummer < 32)
	switch (ucNummer >> 3)					// ucNummer Modulo 8
	{
		case 0:
			return sTrans.E16_Main[ucBit];
		case 1:
			return sTrans.E16_Sub1[ucBit];
		case 2:
			return sTrans.E16_Sub2[ucBit];
		case 3:
			return sTrans.E16_Sub3[ucBit];
	}

	return 0;
}
